wxFilterClassFactory Class Reference | wxWidgets

| Version: 3.2.11

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
wxFilterClassFactory Class Referenceabstract
Class List by Category » Streams

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.2/wxWidgets3.2-3.2.11-1.x86_64/src/wxWidgets-3.2.11/interface/wx/stream.h>`

Inheritance diagram for wxFilterClassFactory:
[legend]

## Detailed Description

Allows the creation of filter streams to handle compression formats such as gzip and bzip2.

For example, given a filename you can search for a factory that will handle it and create a stream to decompress it:

factory = wxFilterClassFactory::Find(filename, wxSTREAM_FILEEXT);
if (factory)
stream = factory->NewStream(new wxFFileInputStream(filename));
wxFFileInputStream
This class represents data read in from a file.
Definition wfstream.h:284
wxFilterClassFactory::Find
static const wxFilterClassFactory * Find(const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL)
A static member that finds a factory that can handle a given protocol, MIME type, HTTP encoding or fi...
wxSTREAM_FILEEXT
@ wxSTREAM_FILEEXT
File extensions the stream handles.
Definition stream.h:826

wxFilterClassFactory::Find can also search for a factory by MIME type, HTTP encoding or by wxFileSystem protocol. The available factories can be enumerated using wxFilterClassFactory::GetFirst() and wxFilterClassFactory::GetNext().

##

Library: wxBase
Category: Streams

See also
  wxFilterInputStream, wxFilterOutputStream, wxArchiveClassFactory, Archive Formats

const wxFilterClassFactory * | GetNext () const
| GetFirst and GetNext can be used to enumerate the available factories.
static const wxFilterClassFactory * | GetFirst ()
| GetFirst and GetNext can be used to enumerate the available factories.

## Public Member Functions
bool | CanHandle (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL) const
| Returns true if this factory can handle the given protocol, MIME type, HTTP encoding or file extension.
wxString | GetProtocol () const
| Returns the wxFileSystem protocol supported by this factory.
virtual const wxChar *const * | GetProtocols (wxStreamProtocolType type=wxSTREAM_PROTOCOL) const =0
| Returns the protocols, MIME types, HTTP encodings or file extensions supported by this factory, as an array of null terminated strings.
wxString | PopExtension (const wxString &location) const
| Remove the file extension of location if it is one of the file extensions handled by this factory.
void | PushFront ()
| Adds this class factory to the list returned by GetFirst()/GetNext().
void | Remove ()
| Removes this class factory from the list returned by GetFirst()/GetNext().
virtual wxFilterInputStream * | NewStream (wxInputStream &stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
virtual wxFilterOutputStream * | NewStream (wxOutputStream &stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
virtual wxFilterInputStream * | NewStream (wxInputStream *stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
virtual wxFilterOutputStream * | NewStream (wxOutputStream *stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.

## Static Public Member Functions
static const wxFilterClassFactory * | Find (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL)
| A static member that finds a factory that can handle a given protocol, MIME type, HTTP encoding or file extension.

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Member Function Documentation

## ◆ CanHandle()

bool wxFilterClassFactory::CanHandle | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = wxSTREAM_PROTOCOL ) const

Returns true if this factory can handle the given protocol, MIME type, HTTP encoding or file extension.

When using `wxSTREAM_FILEEXT` for the second parameter, the first parameter can be a complete filename rather than just an extension.

## ◆ Find()

const wxFilterClassFactory * wxFilterClassFactory::Find | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = wxSTREAM_PROTOCOL )
| static

A static member that finds a factory that can handle a given protocol, MIME type, HTTP encoding or file extension.

Returns a pointer to the class factory if found, or NULL otherwise. It does not give away ownership of the factory.

When using `wxSTREAM_FILEEXT` for the second parameter, the first parameter can be a complete filename rather than just an extension.

## ◆ GetFirst()

const wxFilterClassFactory * wxFilterClassFactory::GetFirst | ( |  | ) |
| static

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

wxString list;
const wxFilterClassFactory *factory = wxFilterClassFactory::GetFirst();
while (factory) {
list << factory->GetProtocol() << wxT("\n");
factory = factory->GetNext();
}
wxFilterClassFactory
Allows the creation of filter streams to handle compression formats such as gzip and bzip2.
Definition stream.h:856
wxFilterClassFactory::GetFirst
static const wxFilterClassFactory * GetFirst()
GetFirst and GetNext can be used to enumerate the available factories.
wxFilterClassFactory::GetNext
const wxFilterClassFactory * GetNext() const
GetFirst and GetNext can be used to enumerate the available factories.
wxFilterClassFactory::GetProtocol
wxString GetProtocol() const
Returns the wxFileSystem protocol supported by this factory.
wxString
String class for passing textual data to or receiving it from wxWidgets.
Definition string.h:315
wxT
#define wxT(string)
This macro can be used with character and string literals (in other words, 'x' or "foo") to automatic...
Definition chartype.h:32

GetFirst()/GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

## ◆ GetNext()

const wxFilterClassFactory * wxFilterClassFactory::GetNext | ( |  | ) | const

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

wxString list;
const wxFilterClassFactory *factory = wxFilterClassFactory::GetFirst();
while (factory) {
list << factory->GetProtocol() << wxT("\n");
factory = factory->GetNext();
}

GetFirst()/GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

## ◆ GetProtocol()

wxString wxFilterClassFactory::GetProtocol | ( |  | ) | const

Returns the wxFileSystem protocol supported by this factory.

Equivalent to

wxString(*GetProtocols())
wxFilterClassFactory::GetProtocols
virtual const wxChar *const * GetProtocols(wxStreamProtocolType type=wxSTREAM_PROTOCOL) const =0
Returns the protocols, MIME types, HTTP encodings or file extensions supported by this factory,...

.

## ◆ GetProtocols()

virtual const wxChar *const * wxFilterClassFactory::GetProtocols | ( | wxStreamProtocolType | type = wxSTREAM_PROTOCOL | ) | const
| pure virtual

Returns the protocols, MIME types, HTTP encodings or file extensions supported by this factory, as an array of null terminated strings.

It does not give away ownership of the array or strings.

For example, to list the file extensions a factory supports:

wxString list;
const wxChar *const *p;
for (p = factory->GetProtocols(wxSTREAM_FILEEXT); *p; p++)
list << *p << wxT("\n");
wxChar
wxUSE_UNICODE_dependent wxChar
wxChar is defined to be - char when wxUSE_UNICODE==0 - wchar_t when wxUSE_UNICODE==1 (the default).
Definition chartype.h:105

## ◆ NewStream() [1/4]

virtual wxFilterInputStream * wxFilterClassFactory::NewStream | ( | wxInputStream & | stream | ) | const
| pure virtual

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## ◆ NewStream() [2/4]

virtual wxFilterInputStream * wxFilterClassFactory::NewStream | ( | wxInputStream * | stream | ) | const
| pure virtual

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## ◆ NewStream() [3/4]

virtual wxFilterOutputStream * wxFilterClassFactory::NewStream | ( | wxOutputStream & | stream | ) | const
| pure virtual

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## ◆ NewStream() [4/4]

virtual wxFilterOutputStream * wxFilterClassFactory::NewStream | ( | wxOutputStream * | stream | ) | const
| pure virtual

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## ◆ PopExtension()

wxString wxFilterClassFactory::PopExtension | ( | const wxString & | location | ) | const

Remove the file extension of location if it is one of the file extensions handled by this factory.

## ◆ PushFront()

void wxFilterClassFactory::PushFront | ( |  | ) |

Adds this class factory to the list returned by GetFirst()/GetNext().

It is not necessary to do this to use the filter streams. It is usually used when implementing streams, typically the implementation will add a static instance of its factory class.

It can also be used to change the order of a factory already in the list, bringing it to the front. This isn't a thread safe operation so can't be done when other threads are running that will be using the list.

The list does not take ownership of the factory.

## ◆ Remove()

void wxFilterClassFactory::Remove | ( |  | ) |

Removes this class factory from the list returned by GetFirst()/GetNext().

Removing from the list isn't a thread safe operation so can't be done when other threads are running that will be using the list.

The list does not own the factories, so removing a factory does not delete it.